<?php

	/**
	 * Dieses Modul ermöglicht die Zahlungsart "Targo"
	 */
	class wpsg_mod_targo extends wpsg_mod_basic
	{
		
		var $lizenz = 1;
		var $id = 17;		
		var $hilfeURL = 'http://wpshopgermany.de/?p=4693700';

		var $url = false; // URL zum Targo Endpunkt, wird von der init() Methode gesetzt
		var $apiContext = false;
		
		const STATUS_CREDIT_ACCEPTED = 350;
		
		/**
		 * Constructor
		 */
		public function __construct()
		{
			
			parent::__construct();
			
			$this->name = __('Targobank', 'wpsg');
			$this->group = __('Zahlungsarten', 'wpsg');
			$this->desc = __('Ermöglicht die Zahlungsart Targobank.', 'wpsg');
						
		} // public function __construct()
		
		public function install()
		{

			$this->shop->checkDefault('wpsg_mod_targo_aktiv', '1');
			$this->shop->checkDefault('wpsg_mod_targo_autostart', '1');
			$this->shop->checkDefault('wpsg_mod_targo_summe_min', '99.00');
			$this->shop->checkDefault('wpsg_mod_targo_summe_max', '12500.00');
			$this->shop->checkDefault('wpsg_mod_targo_laufzeit_min', '6');
			$this->shop->checkDefault('wpsg_mod_targo_laufzeit_max', '60');
			$this->shop->checkDefault('wpsg_mod_targo_rate_min', '10.00');
			$this->shop->checkDefault('wpsg_mod_targo_url_test', '');
			$this->shop->checkDefault('wpsg_mod_targo_url_live', '');
			$this->shop->checkDefault('wpsg_mod_targo_url_use', '0');
			$this->shop->checkDefault('wpsg_mod_targo_koop_id', '');
			$this->shop->checkDefault('wpsg_mod_targo_dealerid', '');
			$this->shop->checkDefault('wpsg_mod_targo_hashkey', '');
			$this->shop->checkDefault('wpsg_mod_targo_success', '');
			$this->shop->checkDefault('wpsg_mod_targo_error', '');
			
			$this->shop->checkDefault('wpsg_mod_targo_bezeichnung', 'Targobank');
			$this->shop->checkDefault('wpsg_mod_targo_hint', 'Ermöglicht die Zahlungsabwicklung mit der Targobank');
			$this->shop->checkDefault('wpsg_mod_targo_createwebhook', '');
			$this->shop->checkDefault('wpsg_mod_targo_gebuehr', '');
			$this->shop->checkDefault('wpsg_mod_targo_mwst', '');
			$this->shop->checkDefault('wpsg_mod_targo_mwstland', '');
				
		} // public function install()
		
		public function settings_edit()
		{
			 
			$pages = get_pages();
			
			$arPages = array(
				'-1' => __('Neu anlegen und zuordnen', 'wpsg')
			);
			
			foreach ($pages as $k => $v)
			{
				$arPages[$v->ID] = $v->post_title.' (ID:'.$v->ID.')';
			}
			
			$this->shop->view['pages'] = $arPages;
			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_targo/settings_edit.phtml');
			
		} // public function settings_edit()
				
		public function settings_save()
		{
			
			$this->shop->update_option('wpsg_mod_targo_aktiv', $_REQUEST['wpsg_mod_targo_aktiv']);
			$this->shop->update_option('wpsg_mod_targo_autostart', $_REQUEST['wpsg_mod_targo_autostart']);
			$this->shop->update_option('wpsg_mod_targo_summe_min', $_REQUEST['wpsg_mod_targo_summe_min']);
			$this->shop->update_option('wpsg_mod_targo_summe_max', $_REQUEST['wpsg_mod_targo_summe_max']);
			$this->shop->update_option('wpsg_mod_targo_laufzeit_min', $_REQUEST['wpsg_mod_targo_laufzeit_min']);
			$this->shop->update_option('wpsg_mod_targo_laufzeit_max', $_REQUEST['wpsg_mod_targo_laufzeit_max']);
			$this->shop->update_option('wpsg_mod_targo_rate_min', $_REQUEST['wpsg_mod_targo_rate_min']);
			$this->shop->update_option('wpsg_mod_targo_url_test', $_REQUEST['wpsg_mod_targo_url_test']);
			$this->shop->update_option('wpsg_mod_targo_url_live', $_REQUEST['wpsg_mod_targo_url_live']);
			$this->shop->update_option('wpsg_mod_targo_url_use', $_REQUEST['wpsg_mod_targo_url_use']);
			$this->shop->update_option('wpsg_mod_targo_koop_id', $_REQUEST['wpsg_mod_targo_koop_id']);
			$this->shop->update_option('wpsg_mod_targo_dealerid', $_REQUEST['wpsg_mod_targo_dealerid']);
			$this->shop->update_option('wpsg_mod_targo_hashkey', $_REQUEST['wpsg_mod_targo_hashkey']);
		
			$this->shop->update_option('wpsg_mod_targo_bezeichnung', $_REQUEST['wpsg_mod_targo_bezeichnung']);
			$this->shop->update_option('wpsg_mod_targo_hint', $_REQUEST['wpsg_mod_targo_hint']);
			//$this->shop->update_option('wpsg_mod_targo_createwebhook', $_REQUEST['wpsg_mod_targo_createwebhook']);
			$this->shop->update_option('wpsg_mod_targo_gebuehr', $_REQUEST['wpsg_mod_targo_gebuehr']);
			$this->shop->update_option('wpsg_mod_targo_mwst', $_REQUEST['wpsg_mod_targo_mwst']);
			$this->shop->update_option('wpsg_mod_targo_mwstland', $_REQUEST['wpsg_mod_targo_mwstland']);
			
			//$this->shop->createPage(__('Erfolgreiche Targo Finanzierung', 'wpsg'), 'wpsg_mod_targo_success', $_REQUEST['wpsg_mod_targo_success']);
			//$this->shop->createPage(__('Fehlgeschlagene Targo Finanzierung', 'wpsg'), 'wpsg_mod_targo_error', $_REQUEST['wpsg_mod_targo_error']);
			
		} // public function settings_save()
				 
		public function addPayment(&$arPayment) 
		{ 
			
			$this->shop->arStatus[self::STATUS_CREDIT_ACCEPTED] = __('Kreditvertrag angenommen', 'wpsg');
			
			if (!is_admin() && $this->shop->get_option('wpsg_mod_targo_aktiv') != '1') return;

			$arBasket = $this->shop->basket->toArray();
				wpsg_debug($arBasket);
			// Bestellungen außerhalb der Targo-Bestimmungen geben nix aus
			$gesamt = $arBasket['sum']['preis_gesamt_brutto'];
			$min = $this->shop->get_option('wpsg_mod_targo_summe_min');
			$max = $this->shop->get_option('wpsg_mod_targo_summe_max');
			if (($gesamt <= $min) || ($gesamt >= $max)) return;
				
			$mwst_value = $this->getTaxValue($this->shop->get_option('wpsg_mod_targo_mwst'), $this->shop->getDefaultCountry());
					
			// Array umsortieren Targo als erstes
			// bei Land != DE Targobank ausblenden
			$land = $arBasket['land']['kuerzel'];
			if ($land == "DE")
			{
			
				$arPaymentTB[$this->id] = array(
					'id' => $this->id,
					'name' => __($this->shop->get_option('wpsg_mod_targo_bezeichnung'), 'wpsg'),
					'preis' => $this->shop->get_option('wpsg_mod_targo_gebuehr'),
					'mwst' => $this->shop->get_option('wpsg_mod_targo_mwst'),
					'mwst_value' => $mwst_value,
					'mwst_null' => $this->shop->get_option('wpsg_mod_targo_mwstland'),
					'hint' => __($this->shop->get_option('wpsg_mod_targo_hint')),
					'logo' => $this->shop->getRessourceURL('gfx/targologo.png')
				);
				$arPayment = wpsg_array_merge($arPaymentTB, $arPayment);
				
			}
			
			if (isset($_REQUEST['wpsg_checkout2']) || ($this->shop->hasMod('wpsg_mod_onepagecheckout') && isset($_REQUEST['wpsg_checkout'])))
			{

				if ($this->shop->get_option('wpsg_preisangaben') == WPSG_NETTO || $arBasket['noMwSt'])
				{
						
					$payment_netto = $this->getPreis($this->shop->get_option('wpsg_mod_targo_gebuehr'), $arBasket['sum']['preis']);
					$payment_brutto = wpsg_calculatePreis($payment_netto, WPSG_BRUTTO, $mwst_value);
						
				}
				else
				{
												
					$payment_brutto = $this->getPreis($this->shop->get_option('wpsg_mod_targo_gebuehr'), $arBasket['sum']['preis']);																								
					$payment_netto = wpsg_calculatePreis($payment_brutto, WPSG_NETTO, $mwst_value);						
						
				}
				
				// Entsprechenden Preis anzeigen
				if ($this->shop->getFrontendTaxview() == WPSG_NETTO)
				{
					
					$arPayment[$this->id]['price'] = $payment_netto;
					
				}
				else 
				{
					
					$arPayment[$this->id]['price'] = $payment_brutto;
					
				}
				
			}
			
		} // public function addPayment(&$arPayment)
		
		public function calcPayment(&$arBasket) 
		{ 
			
			if ($arBasket['checkout']['payment'] == $this->id)
			{
			 
				$payment_price = $this->getPreis($this->shop->get_option('wpsg_mod_targo_gebuehr'), $arBasket['sum']['preis']);
				
				if ($this->shop->get_option('wpsg_mod_targo_mwstland') == '1' && $arBasket['noMwSt'])
				{
					
					// Keine MwSt. berechnen !
					$arBasket['sum']['preis_payment'] = $payment_price;
					$arBasket['sum']['preis_payment_brutto'] = $payment_price;
					$arBasket['sum']['preis_payment_netto'] = $payment_price;
					
					$arBasket['payment']['mwst'] = 0;
					$this->shop->arPayment[$arBasket['checkout']['payment']]['mwst_value'] = 0;
						
					$arBasket['payment']['tax_rata'] = false;
					
				}
				else
				{
					
					// MwSt berechnen (Angaben im Backend sind immer Brutto)
					$this->setPaymentKosten($arBasket, $payment_price, $this->shop->get_option('wpsg_mod_targo_mwst'));

				}
								
			}
			
		} // public function calcPayment(&$arBasket) 
				
		public function order_view_afterpayment(&$order_id)
		{
		
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_targo/order_view_afterpayment.phtml');
		
		} // public function order_view_sidebar(&$order_id)
		
		public function order_done(&$order_id, &$done_view) 
		{ 
 
			// Bestellungen mit 0 geben nix aus
			if ($done_view['basket']['sum']['preis_gesamt_brutto'] <= 0 || $this->shop->view['basket']['checkout']['payment'] != $this->id) return;
			
			$oOrder = wpsg_order::getInstance($order_id);
							
			$this->shop->view['targoLink'] = $this->getTargoLink($order_id);
			$this->shop->view['o_id'] = $order_id;
			$kid = $oOrder->k_id;
			$this->shop->view['k_id'] = $oOrder->k_id;
			
			echo $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_targo/order_done.phtml', false);
						
		} // public function order_done(&$order_id)

		/* Modulfunktionen */
				
		/**
		 * Gibt den Link für die Bezahlung per Targo anhand der BestellID zurück
		 */
		public function getTargoLink($order_id)
		{

			return	$wh_url = $this->shop->getUrl(wpsg_ShopController::URL_BASKET, 'wpsg_mod_targo', 'dealerText', array('order_id' => $order_id, 'wert' => $order_id), false);
		
		} // public function getTargoLink($order_id)
		
				
		public function dealerTextRedirect()
		{
			
			//die("dealerTextRedirekt");
/*
			$empfaenger = "hartmut@maennchen1.de";
			$betreff = "Mail-Funktion";
			$from = "From: Name <hartmut@maennchen1.de>\n";
			$from .= "Reply-To: hartmut@maennchen1.de\n";
			$from .= "Content-Type: text/html\n";
			$text = "Mail von dealerTextRedirect:_  ".print_r($_REQUEST, 1);
			
			mail($empfaenger, $betreff, $text, $from);
*/						
			//$url = "https://onlineapplication.uat.targobank.de/microsites/statustool/interface/request.asp" 
			
			$order_id = $_REQUEST['order_id'];
			// PAID speichern zu Bestellung
			$oOrder = wpsg_order::getInstance($order_id);
			$oOrder->setMeta('wpsg_mod_targo_paymentid', $_REQUEST['paid']);
			
			// Status umschalten (wpsg_ShopController->setOrderStatus($order_id, $status_id, $inform))
			// $inform sollte false sein, sonst bekommt der Kunde eine E-Mail $status_id ist wpsg_mod_targo::STATUS_CREDIT_ACCEPTED
			$sc = new wpsg_ShopController();
			$sc->setOrderStatus($order_id, STATUS_CREDIT_ACCEPTED, false);
			
			// Log Eintrag speichern wpsg_order->log
			// [session_id] => 1tm24iqd49c4cg1ct834bvqnp0 [paid] => 201610252052880
			$text = 'Session-ID: '.$_REQUEST['session_id'].'  PAID: '.$_REQUEST['paid'];
			$oOrder->log('Rückantwort der Targobank', $text);
			
		} // public function dealerTextRedirect()
		
	} // class wpsg_mod_targo extends wpsg_mod_basic

?>